SystemOrganization addCategory: #'Ring-History-Browsers'!

!RGSnapshotGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 17:55'!
viewSnapshotGraph: view selectedSnapshot: selectedSnapshot selectedSuccessor: selectedSuccessor

	view nodeShape
		borderColor: [ :each| each borderColorNode: (selectedSnapshot ifNil:[ #() ] ifNotNil:[ :s| s successors ]) ];
		fillColor:[ :each| each colorNode: selectedSnapshot successor: selectedSuccessor ].
	view nodes: self snapshots forEach:[ :snap|
		view nodeShape
			borderColor:[ :each| each borderColorNode ];
			fillColor:[ :each| each colorNode ].
		view nodes: snap commit packages.
		view nodeShape
			borderStyle:[ :each| BorderStyle dashed ];
			borderColor:[ :each| each borderColorNode ];
			fillColor:[ :each| each colorNode ]. 
		view nodes: snap nonCommitPackages.
		view flowLayout maxWidth: 40 ].
	view edges: self snapshots from: [ :n| n ] toAll:[ :n | n successors ].
	view horizontalDominanceTreeLayout 
		verticalGap: 8! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/23/2011 10:48'!
timedName

	^self fullName, ' (', self firstVersion timeStamp asString, ')'! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/27/2011 12:19'!
viewVersionHistoryOn: view
	| nodes |
	nodes := self withAllPredecessors.

	view shape rectangle.
	view interaction popupText: [ :each| each timedName ].
	view nodes: nodes.
	view edges: nodes
		from: [ :each | each ] 
		toAll: [ :each | each predecessors ].

	view dominanceTreeLayout ! !

!RGCommitNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 11:36'!
borderColorNode

	^Color black! !

!RGCommitNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 14:31'!
borderColorNode:  aCollection

	^(aCollection detect:[ :each| each = self ] ifNone:[ nil ])
		ifNil: [ self borderColorNode ]
		ifNotNil:[ Color magenta ]! !

!RGCommitNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 14:16'!
colorNode: selectedCommit successor: selectedSuccessor 

	^self = selectedCommit
		ifTrue: [ Color cyan ]
		ifFalse:[ 
			self = selectedSuccessor
				ifTrue: [ Color magenta ]
				ifFalse:[ Color transparent ] ]! !

!RGPackageGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 11:15'!
uniqueSuccessorsPerPackage: packageName
	| uniqueSuccessors |

	uniqueSuccessors := Set new.
	(roots at: packageName)
		do:[ :root|  uniqueSuccessors addAll: root allSuccessors ].
		
	^uniqueSuccessors! !

!RGPackageGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 16:43'!
viewPackageGraph: view selectedPackages: selectedPackages
	| nodes value withAllSuccessors uniqueSuccessors |
	
	selectedPackages isEmptyOrNil
		ifTrue: [ nodes := self packageNames sort: [:e1 :e2 | e1 name <= e2 name] ]
		ifFalse:[ nodes := selectedPackages ].
	nodes do:[ :key|
		value := roots at: key.
		withAllSuccessors := self uniqueSuccessorsPerPackage: key.
		withAllSuccessors addAll: value.
		view nodeShape 
			withoutBorder;
			text: [ :each | each ].
		view node: key.
		view nodeShape withoutBorder.
		view noInteraction.
		view node: nil forIt:[
			view nodeShape
				borderColor:[ :each| each borderColorNode ];
				fillColor:[ :each| each colorNode ].
			view nodes: withAllSuccessors.
			view edges: withAllSuccessors from: [ :n| n ] toAll:[ :n | n successors ].
			view horizontalDominanceTreeLayout
			].
		view verticalLineLayout.
		 ]. ! !

!RGRepositorySnapshot methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/8/2011 14:01'!
viewComparativeClassesHistoryOn: view
	| predecCollection classesIDs classCollection forEdges |
	
	predecCollection := self withAllPredecessors.
	classesIDs := self classIDs.
	forEdges := OrderedCollection new.

	view nodeShape withoutBorder.
	view noInteraction.
	view node: nil forIt: [
	predecCollection do:[ :pred|
		classCollection := OrderedCollection new.
		view nodeShape
			borderColor: [ :each| Color lightGray ]; 
			borderStyle: [ :each| BorderStyle dashed ].
		view node: pred forIt:[
			| clsNode hasBorder metaNode |
			classesIDs do:[ :cls|
				hasBorder := false.
				metaNode := nil.
				clsNode := pred historyAtID: cls.
				clsNode notNil ifTrue: [ metaNode := clsNode theMetaClass ].
				(pred wasHistoryRemoved: clsNode)
					ifTrue: [ hasBorder := true.
							view nodeShape fillColor:[ :e| Color red ] ].
				((pred wasHistoryModified: clsNode) or:[ pred wasHistoryModified: metaNode ])
					ifTrue: [ hasBorder := true.
							view nodeShape fillColor:[ :e| Color blue ] ].
				(pred wasHistoryAdded: clsNode)
					ifTrue: [ hasBorder := true.
							view nodeShape fillColor:[ :e| Color green ] ].
				hasBorder 
					ifFalse:[ 
						view nodeShape withoutBorder.
						view noInteraction.
						view node: nil ]
					ifTrue:[ 
						classCollection add: clsNode.
						view node: clsNode ] ].
			view horizontalLineLayout ].
		
		forEdges add: classCollection..	
		view verticalLineLayout  ] ].

	forEdges do:[ :collection |
		view edges: collection
			from: [ :each | each ] 
			toAll: [ :each | each unwrappedSuccessors ] ].
"	view treeLayout."! !

!RGCommitGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 17:01'!
viewCommitGraph: view selectedCommit: selectedCommit selectedSuccessor: selectedSuccessor
	
	view nodeShape
		borderColor: [ :each| each borderColorNode: (selectedCommit ifNil:[ #() ] ifNotNil:[ :s| s successors ]) ];
		fillColor:[ :each| each colorNode: selectedCommit successor: selectedSuccessor ].
	view nodes: self commitNodes forEach:[ :commit|
		view nodeShape
			borderColor:[ :each| each borderColorNode ];
			fillColor:[ :each| each colorNode ]. 
		view nodes: commit packages.
		view flowLayout maxWidth: 40 ].
	view edges: self commitNodes from: [ :n| n ] toAll:[ :n | n successors ].
	view horizontalDominanceTreeLayout 
		verticalGap: 8! !

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 16:55'!
borderColorNode

	^Color black! !

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 16:55'!
borderColorNode:  aCollection

	^(aCollection detect:[ :each| each = self ] ifNone:[ nil ])
		ifNil: [ self borderColorNode ]
		ifNotNil:[ Color magenta ]! !

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 16:54'!
colorNode: selectedCommit successor: selectedSuccessor 

	^self = selectedCommit
		ifTrue: [ Color cyan ]
		ifFalse:[ 
			self = selectedSuccessor
				ifTrue: [ Color magenta ]
				ifFalse:[ Color transparent ] ]! !

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 17:46'!
nonCommitPackages

	^packages difference: commit packages! !

!RGPackageHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/4/2011 10:36'!
summary

	^ String streamContents: [:s |
		s
			nextPutAll: 'Version: '; 
			nextPutAll: self versionName asString; cr; 
			nextPutAll: 'Author: '; 
			nextPutAll: self author asString; cr; 
			nextPutAll: 'Timestamp: ';
			nextPutAll: self timeStamp asString; cr; 
			nextPutAll: 'Repository: '; 
			nextPutAll: self repositoryLocation asString; cr; cr;
			nextPutAll: self commitMessage asString ]! !

!RGPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 14:32'!
borderColorNode

	^self isExternal
		ifTrue: [ Color blue ]
		ifFalse:[ Color black ]! !

!RGPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 14:32'!
colorNode

	^self isExternal
		ifTrue: [ Color blue ]
		ifFalse:[ Color white ]! !

!RGMissingPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/8/2011 17:10'!
borderColorNode

	^self colorNode! !

!RGMissingPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 14:32'!
colorNode

	^Color red! !

Object subclass: #RGAbstractBrowser
	instanceVariableNames: 'browser model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGAbstractBrowser classSide methodsFor: 'opening' stamp: 'VeronicaUquillas 8/3/2011 16:29'!
open

	^self new open! !

!RGAbstractBrowser classSide methodsFor: 'opening' stamp: 'VeronicaUquillas 8/4/2011 15:17'!
open: model

	^self new 
		model: model;
		open! !

!RGAbstractBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/12/2011 11:18'!
browser

	^ browser ifNil:[ self buildBrowser. browser]! !

!RGAbstractBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 7/12/2011 11:42'!
buildBrowser

	browser := GLMTabulator new.
	browser title: self titleBrowser.
	self layout! !

!RGAbstractBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/4/2011 14:58'!
defaultActions: anObject

	^OrderedCollection new
		add: (self inspectAction: anObject);
		yourself! !

!RGAbstractBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/4/2011 14:57'!
inspectAction: anObject

	^GLMGenericAction new 
		title: 'Inspect'; 
		action: [ anObject selection inspect ]; 
		yourself! !

!RGAbstractBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 7/12/2011 11:19'!
layout

	self subclassResponsibility ! !

!RGAbstractBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/12/2011 11:20'!
model

	^model! !

!RGAbstractBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/12/2011 11:20'!
model: anObject

	model := anObject ! !

!RGAbstractBrowser methodsFor: 'opening' stamp: 'VeronicaUquillas 7/12/2011 11:42'!
open
	
	self browser openOn: self model 
	"with: (TCMorphicRenderer new
					extent: self extent)"! !

!RGAbstractBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 8/22/2011 16:23'!
sortByName: aCollection

	^ aCollection sort: [:e1 :e2 | e1 name <= e2 name]! !

!RGAbstractBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 8/22/2011 16:23'!
sortByTimestamp: aCollection

	^ aCollection sort: [:e1 :e2 | e1 timeStamp <= e2 timeStamp ]! !

!RGAbstractBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 7/12/2011 11:19'!
titleBrowser

	self subclassResponsibility ! !

RGAbstractBrowser subclass: #RGCommitGraphBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGCommitGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 13:31'!
buildBrowser

	super buildBrowser.
	self onCommits.
	self onPackages.
	self onSuccessors.
	self onCommitGraph! !

!RGCommitGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:57'!
layout

	browser
		column: [:c | c row: #commits span: 4; row: #packages span: 2; row: #successors ]; 
		column: #commitGraph span: 4.! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 14:41'!
onCommitGraph

	browser
		showOn: #commitGraph;
		from: #commits;
		from: #successors;
		using: [
			browser mondrian 
				allowNil;
				painting: [ :view :commit :successor |
					self model viewCommitGraph: view selectedCommit: commit selectedSuccessor: successor]
		].
	
	"Need initial display"
	browser transmit to: #commitGraph; andShow: [:a | 
		a mondrian 
			painting: [ :view | self model viewCommitGraph: view selectedCommit: nil selectedSuccessor: nil ] ].
! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 13:34'!
onCommits

	browser transmit
		to: #commits;
		andShow: [:a |
			a list
			title: 'Commits';
			display: [ :each| self model commitNodes ];
			format: [ :each| each name ]
		].! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:29'!
onPackages

	browser transmit
		to: #packages;
		from: #commits;
		andShow: [:a |
			a list
			title: 'Packages';
			display: [ :each| self sortByName: each packages asOrderedCollection ];
			format:[ :each| each name ]
		].! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 10:51'!
onSuccessors

	browser transmit
		to: #successors;
		from: #commits;
		andShow: [:a |
			a list
			title: 'Successors';
			display: [ :each| each successors ];
			format:[ :each| each name ]
		].! !

!RGCommitGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 10:38'!
titleBrowser

	^'Commit Evolution Graph'! !

RGAbstractBrowser subclass: #RGComparativeClassHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGComparativeClassHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/8/2011 12:59'!
buildBrowser

	super buildBrowser.
	self onClasses.
	self onComparativeClasses! !

!RGComparativeClassHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/8/2011 13:04'!
layout

	browser
		column: #classes;
		column: #comparativeHistory span: 3.! !

!RGComparativeClassHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/8/2011 14:25'!
onClasses

	browser transmit
		to: #classes;
		andShow: [:a |
			a list
			title: 'Classes';
			display: [ :each| self model sortedClassesWithRemovals ];
			format:[ :each| each name ]";
			dynamicActionsOnSelection: [ :each | self defaultActions: each ]"
		].! !

!RGComparativeClassHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/8/2011 13:33'!
onComparativeClasses

	browser
		showOn: #comparativeHistory;
		using: [
			browser mondrian 
				painting: [ :view :entity |
					self model viewComparativeClassesHistoryOn: view ].
		].! !

!RGComparativeClassHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 16:11'!
titleBrowser

	^model timeStamp asString, ' (', model author, ')'! !

RGAbstractBrowser subclass: #RGEntityHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGEntityHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 15:03'!
buildBrowser

	super buildBrowser.
	self onPackages.
	self onClasses.
	self onMethods.
	self onPackageHistory.
	self onClassHistory.
	self onMethodHistory! !

!RGEntityHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 14:56'!
layout

	browser
		row: [:c | c column: #packages; column: #classes; column: #methods ]; 
		row: [:c | c column: #packageHistory; column: #classHistory; column: #methodHistory ]! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:55'!
onClassHistory

	browser
		showOn: #classHistory;
		from: #classes;
		using: [
			self onHistory
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/8/2011 13:12'!
onClasses

	browser transmit
		to: #classes;
		from: #packages; 
		andShow: [:a |
			a list
			title: 'Classes';
			display: [ :package| package sortedDefinedClasses ];
			format:[ :each| each name ];
			when:[ :package | package sortedDefinedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ].
			
			a list
			title: 'Extended Classes';
			display: [ :package| package sortedExtendedClasses ];
			format:[ :each| each name ];
			when:[ :package | package sortedExtendedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ].
		].	! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 15:22'!
onHistory

	browser mondrian 
		painting: [ :view :entity |
					entity viewVersionHistoryOn: view ].
! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:55'!
onMethodHistory

	browser
		showOn: #methodHistory;
		from: #methods;
		using: [
			self onHistory
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/8/2011 13:13'!
onMethods

	browser transmit
		to: #methods;
		from: #classes; 
		from: #packages;
		andShow: [:a |
			a list
			title: 'Methods';
			display: [ :class :pack | (class methodsInPackage: pack) sort: class sortByName  ];
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ]
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:55'!
onPackageHistory

	browser
		showOn: #packageHistory;
		from: #packages;
		using: [
			self onHistory
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:58'!
onPackages

	browser transmit
		to: #packages;
		andShow: [:a |
			a list
			title: 'Packages';
			display: [ :version| self model sortedPackages ];
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ]
		].! !

!RGEntityHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 15:21'!
titleBrowser

	^model timeStamp asString, ' (', model author, ')'! !

RGAbstractBrowser subclass: #RGPackageGraphBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGPackageGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:11'!
buildBrowser

	super buildBrowser.
	self onPackages.
	self onRepositories.
	self onPackageGraph.! !

!RGPackageGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:11'!
layout

	browser
		column: [:c | c row: #packages span: 3; row: #repositories ]; 
		column: #packageGraph span: 4.! !

!RGPackageGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:15'!
onPackageGraph

	browser
		showOn: #packageGraph;
		from: #packages;
		using: [
			browser mondrian 
				allowNil;
				painting: [ :view :packages | 
					self model viewPackageGraph: view selectedPackages: packages ].
		].
	
	"Need initial display"
	browser transmit to: #packageGraph; andShow: [:a | 
		a mondrian 
			painting: [ :view | self model viewPackageGraph: view selectedPackages: #() ] ].! !

!RGPackageGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:25'!
onPackages

	browser transmit
		to: #packages;
		andShow: [:a |
			a list
			title: 'Packages';
			beMultiple;
			display: [ :each| self sortByName: (self model packageNames) ]
		].! !

!RGPackageGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/8/2011 17:17'!
onRepositories

	browser transmit
		to: #repositories;
		andShow: [:a |
			a list
			title: 'Repositories';
			display: [ :each| self model repositories ];
			format:[ :each| each description ]
		].! !

!RGPackageGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:12'!
titleBrowser

	^'Package Evolution Graph'! !

RGAbstractBrowser subclass: #RGRepositoryHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGRepositoryHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 7/29/2011 15:17'!
buildBrowser

	super buildBrowser.
	self onSnapshots.
	self onPackages.
	self onPackageInfo.
	self onClasses.
	self onClassDefinition.
	self onMethods.
	self onSourceCode.
	self onAssociations! !

!RGRepositoryHistoryBrowser methodsFor: 'importing- to remove' stamp: 'VeronicaUquillas 7/12/2011 14:22'!
importHistory
	| repository importer |

	repository := MCHttpRepository location:'http://www.squeaksource.com/Ring' user:'' password:''.
	
	RGHistoryRepository current clear.
	importer := RGHistoryImporterMonticello onRepository:  repository.
	importer toImport: 'Ring-*'; excluding: #('*-core' '*-FileContents').
	importer import.
	
	^RGHistoryRepository current ! !

!RGRepositoryHistoryBrowser methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 7/12/2011 13:57'!
initialize 

	super initialize.
	self model: "self importHistory"  RGHistoryRepository current! !

!RGRepositoryHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 15:01'!
layout

	browser
		column: #snapshots; 
		column: [:c | c row: #packages span: 3; row: #packageInfo ]; 
		column: [:c | c row: #classes span: 2; row: #classDefinition ];
		column: [:c | c row: #methods; row: #sourceCode; row: #associations ]! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:58'!
onAssociations
	| innerBrowser |
	
"	innerBrowser:= GLMTabulator new.
	innerBrowser row: #invocations; row: #accesses; row: #references."
	innerBrowser := GLMStacker new.
	innerBrowser aPane: #invocations; aPane: #accesses; aPane: #references.
	innerBrowser transmit to: #invocations; fromOutside: #entity; andShow: [:a | 
			a title: 'Invocations'.
			a  list
				display: [ :mth| mth invocations ];
				format:[ :each| each name ] ].
	innerBrowser transmit to: #accesses; fromOutside: #entity; andShow: [:a | 
			a title: 'Accesses'.
			a list				
				display: [ :mth| mth accesses ];
				format:[ :each| each name ] ].
	innerBrowser transmit to: #references; fromOutside: #entity; andShow: [:a | 
			a title: 'References'.
			a list
				display: [ :mth| mth references ];
				format:[ :each| each name ] ].
			 
	browser
		showOn: #associations;
		from: #methods;
		using: [
			browser custom: innerBrowser ]! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:59'!
onClassDefinition

	browser
		showOn: #classDefinition;
		from: #classes;
		using: [
		browser text
			title: 'Definition';
			display: [ :cls| cls definitionSource, String crlfcrlf, cls theMetaClass definitionSource ];
			when: [ :cls| cls package isExternal not ].

		browser text
			title: 'Comment';
			display: [ :cls| cls comment content ];
			when:[ :cls| cls hasComment ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/8/2011 13:10'!
onClasses

	browser transmit
		to: #classes;
		from: #packages; 
		andShow: [:a |
			a list
			title: 'Classes';
			display: [ :package| package sortedDefinedClasses ];
			format:[ :each| each name ];
			when:[ :package | package sortedDefinedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ].
			
			a list
			title: 'Extended Classes';
			display: [ :package| package sortedExtendedClasses ];
			format:[ :each| each name ];
			when:[ :package | package sortedExtendedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ].
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/8/2011 11:21'!
onMethods

	browser transmit
		to: #methods;
		from: #classes; 
		from: #packages;
		andShow: [:a |
			a list
			title: 'Methods';
			display: [ :class :pack | (class methodsInPackage: pack) sort: class sortByName  ];
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/3/2011 16:43'!
onPackageInfo

	browser
		transmit to: #packageInfo;
		from: #packages;
		andShow: [:a | 
			a text display: [ :each | each summary ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 15:00'!
onPackages

	browser transmit
		to: #packages;
		from: #snapshots; 
		andShow: [:a |
			a list
			title: 'Packages';
			display: [ :version| version sortedPackages ];
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/8/2011 13:04'!
onSnapshots

	browser
		showOn: #snapshots;
		using: [
		browser list
			title: 'Snapshots';
			display: self model snapshots;
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) 
														add: (self viewHistoryAction: each); 
														add: (self viewComparativeClassesAction: each);
													yourself ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 7/13/2011 15:50'!
onSourceCode

	browser
		showOn: #sourceCode;
		from: #methods;
		using: [
		browser text
			"title: 'SourceCode';"
			display: [ :mth| mth sourceCode ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/3/2011 17:29'!
titleBrowser

	^self model description! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/8/2011 13:03'!
viewComparativeClassesAction: anObject

	^GLMGenericAction new 
		title: 'View Comparative Classes'; 
		action: [ RGComparativeClassHistoryBrowser open: anObject selection ]; 
		yourself! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/4/2011 15:16'!
viewHistoryAction: anObject

	^GLMGenericAction new 
		title: 'View History'; 
		action: [ RGEntityHistoryBrowser open: anObject selection ]; 
		yourself! !

RGAbstractBrowser subclass: #RGSnapshotGraphBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGSnapshotGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 16:51'!
buildBrowser

	super buildBrowser.
	self onSnapshots.
	self onPackages.
	self onSuccessors.
	self onSnapshotGraph ! !

!RGSnapshotGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 16:49'!
layout

	browser
		column: [:c | c row: #snapshots span: 3; row: #packages; row: #successors ]; 
		column: #snapshotGraph span: 4.! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:31'!
onPackages

	browser transmit
		to: #packages;
		from: #snapshots;
		andShow: [:a |
			a list
			title: 'Packages';
			display: [ :each| self sortByName: each packages asOrderedCollection ];
			format:[ :each| each name ]
		].! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 16:50'!
onSnapshotGraph

	browser
		showOn: #snapshotGraph;
		from: #snapshots;
		from: #successors;
		using: [
			browser mondrian 
				allowNil;
				painting: [ :view :snapshot :successor |
					self model viewSnapshotGraph: view selectedSnapshot: snapshot selectedSuccessor: successor]
		].
	
	"Need initial display"
	browser transmit to: #snapshotGraph; andShow: [:a | 
		a mondrian 
			painting: [ :view | self model viewSnapshotGraph: view selectedSnapshot: nil selectedSuccessor: nil ] ].
! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 16:50'!
onSnapshots

	browser transmit
		to: #snapshots;
		andShow: [:a |
			a list
			title: 'Snapshots';
			display: [ :each| self model snapshots ];
			format: [ :each| each name ]
		].! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 16:56'!
onSuccessors

	browser transmit
		to: #successors;
		from: #snapshots;
		andShow: [:a |
			a list
			title: 'Successors';
			display: [ :each| each successors ];
			format:[ :each| each name ]
		].! !

!RGSnapshotGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 16:51'!
titleBrowser

	^'Snapshot Evolution Graph'! !
